]> git.ipfire.org Git - ipfire-2.x.git/blame_incremental - make.sh
Add new usb network devices to kudzu
[ipfire-2.x.git] / make.sh
... / ...
CommitLineData
1#!/bin/bash
2############################################################################
3# #
4# This file is part of the IPFire Firewall. #
5# #
6# IPFire is free software; you can redistribute it and/or modify #
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
11# IPFire is distributed in the hope that it will be useful, #
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
17# along with IPFire; if not, write to the Free Software #
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
20# Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21# #
22############################################################################
23#
24
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
27VERSION="2.2-test"
28GIT_BRANCH=rspezial:rspezial # Version number
29SLOGAN="www.ipfire.org" # Software slogan
30CONFIG_ROOT=/var/ipfire # Configuration rootdir
31NICE=10 # Nice level
32MAX_RETRIES=1 # prefetch/check loop
33KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
34MACHINE=`uname -m`
35
36IPFVER="full" # Which versions should be compiled? (full|devel)
37
38# Debian specific settings
39if [ ! -e /etc/debian_version ]; then
40 FULLPATH=`which $0`
41else
42 if [ -x /usr/bin/realpath ]; then
43 FULLPATH=`/usr/bin/realpath $0`
44 else
45 echo "ERROR: Need to do apt-get install realpath"
46 exit 1
47 fi
48fi
49
50PWD=`pwd`
51BASENAME=`basename $0`
52BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
53LOGFILE=$BASEDIR/log/_build.preparation.log
54export BASEDIR LOGFILE
55DIR_CHK=$BASEDIR/cache/check
56mkdir $BASEDIR/log/ 2>/dev/null
57
58# Include funtions
59. tools/make-functions
60
61if [ -f .config ]; then
62 . .config
63else
64 echo -e "${BOLD}No configuration found!${NORMAL}"
65 echo -ne "Do you want to create one (y/N)?"
66 read CREATE_CONFIG
67 echo ""
68 if [ "$CREATE_CONFIG" == "y" ]; then
69 make_config
70 fi
71fi
72
73if [ -z $EDITOR ]; then
74 for i in nano emacs vi; do
75 EDITOR=$(which $i 2>/dev/null)
76 if ! [ -z $EDITOR ]; then
77 export EDITOR=$EDITOR
78 break
79 fi
80 done
81 [ -z $EDITOR ] && exiterror "You should have installed an editor."
82fi
83
84prepareenv() {
85 ############################################################################
86 # #
87 # Are we running the right shell? #
88 # #
89 ############################################################################
90 if [ ! "$BASH" ]; then
91 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
92 fi
93
94 if [ -z "${BASH_VERSION}" ]; then
95 exiterror "Not running BASH shell."
96 fi
97
98
99 ############################################################################
100 # #
101 # Trap on emergency exit #
102 # #
103 ############################################################################
104 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
105
106
107 ############################################################################
108 # #
109 # Resetting our nice level #
110 # #
111 ############################################################################
112 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
113 renice $NICE $$ > /dev/null
114 if [ `nice` != "$NICE" ]; then
115 beautify message FAIL
116 exiterror "Failed to set correct nice level"
117 else
118 beautify message DONE
119 fi
120
121
122 ############################################################################
123 # #
124 # Checking if running as root user #
125 # #
126 ############################################################################
127 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
128 if [ `id -u` != 0 ]; then
129 beautify message FAIL
130 exiterror "Not building as root"
131 else
132 beautify message DONE
133 fi
134
135
136 ############################################################################
137 # #
138 # Checking for necessary temporary space #
139 # #
140 ############################################################################
141 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
142 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
143 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
144 if (( 2048000 > $BASE_ASPACE )); then
145 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
146 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
147 beautify message FAIL
148 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
149 fi
150 else
151 beautify message DONE
152 fi
153
154 ############################################################################
155 # #
156 # Building Linux From Scratch system #
157 # #
158 ############################################################################
159 # Set umask
160 umask 022
161
162 # Set LFS Directory
163 LFS=$BASEDIR/build
164
165 # Check /tools symlink
166 if [ -h /tools ]; then
167 rm -f /tools
168 fi
169 if [ ! -a /tools ]; then
170 ln -s $BASEDIR/build/tools /
171 fi
172 if [ ! -h /tools ]; then
173 exiterror "Could not create /tools symbolic link."
174 fi
175
176 # Setup environment
177 set +h
178 LC_ALL=POSIX
179 MAKETUNING="-j6"
180 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
181 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
182
183 # Make some extra directories
184 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
185 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
186 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
187 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
188
189 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
190 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
191
192 # Make all sources and proc available under lfs build
193 mount --bind /dev $BASEDIR/build/dev
194 mount --bind /dev/pts $BASEDIR/build/dev/pts
195 mount --bind /dev/shm $BASEDIR/build/dev/shm
196 mount --bind /proc $BASEDIR/build/proc
197 mount --bind /sys $BASEDIR/build/sys
198 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
199 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
200 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
201 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
202 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
203 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
204 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
205 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
206 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
207
208 # This is a temporary hack!!!
209 if [ ! -f /tools/bin/hostname ]; then
210 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
211 fi
212
213 # Run LFS static binary creation scripts one by one
214 export CCACHE_DIR=$BASEDIR/ccache
215 export CCACHE_HASHDIR=1
216
217 # Remove pre-install list of installed files in case user erase some files before rebuild
218 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
219}
220
221buildtoolchain() {
222 LOGFILE="$BASEDIR/log/_build.toolchain.log"
223 export LOGFILE
224 ORG_PATH=$PATH
225 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
226 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
227 lfsmake1 ccache
228 lfsmake1 binutils PASS=1
229 lfsmake1 gcc PASS=1
230 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
231 lfsmake1 linux-libc-header
232 lfsmake1 glibc
233 lfsmake1 cleanup-toolchain PASS=1
234 lfsmake1 tcl
235 lfsmake1 expect
236 lfsmake1 dejagnu
237 lfsmake1 gcc PASS=2
238 lfsmake1 binutils PASS=2
239 lfsmake1 ncurses
240 lfsmake1 bash
241 lfsmake1 bzip2
242 lfsmake1 coreutils
243 lfsmake1 diffutils
244 lfsmake1 findutils
245 lfsmake1 gawk
246 lfsmake1 gettext
247 lfsmake1 grep
248 lfsmake1 gzip
249 lfsmake1 m4
250 lfsmake1 make
251 lfsmake1 patch
252 lfsmake1 perl
253 lfsmake1 sed
254 lfsmake1 tar
255 lfsmake1 texinfo
256 lfsmake1 util-linux
257 lfsmake1 cleanup-toolchain PASS=2
258 export PATH=$ORG_PATH
259}
260
261buildbase() {
262 LOGFILE="$BASEDIR/log/_build.base.log"
263 export LOGFILE
264 lfsmake2 stage2
265 lfsmake2 linux-libc-header
266 lfsmake2 man-pages
267 lfsmake2 glibc
268 lfsmake2 cleanup-toolchain PASS=3
269 lfsmake2 binutils
270 lfsmake2 gcc
271 lfsmake2 berkeley
272 lfsmake2 coreutils
273 lfsmake2 iana-etc
274 lfsmake2 m4
275 lfsmake2 bison
276 lfsmake2 ncurses
277 lfsmake2 procps
278 lfsmake2 sed
279 lfsmake2 libtool
280 lfsmake2 perl
281 lfsmake2 readline
282 lfsmake2 zlib
283 lfsmake2 autoconf
284 lfsmake2 automake
285 lfsmake2 bash
286 lfsmake2 bzip2
287 lfsmake2 diffutils
288 lfsmake2 e2fsprogs
289 lfsmake2 ed
290 lfsmake2 file
291 lfsmake2 findutils
292 lfsmake2 flex
293 lfsmake2 gawk
294 lfsmake2 gettext
295 lfsmake2 grep
296 lfsmake2 groff
297 lfsmake2 gzip
298 lfsmake2 inetutils
299 lfsmake2 iproute2
300 lfsmake2 kbd
301 lfsmake2 less
302 lfsmake2 libaal
303 lfsmake2 make
304 lfsmake2 man
305 lfsmake2 mktemp
306 lfsmake2 modutils
307 lfsmake2 mtd
308 lfsmake2 net-tools
309 lfsmake2 patch
310 lfsmake2 psmisc
311 lfsmake2 reiser4progs
312 lfsmake2 shadow
313 lfsmake2 sysklogd
314 lfsmake2 sysvinit
315 lfsmake2 tar
316 lfsmake2 texinfo
317 lfsmake2 udev
318 lfsmake2 util-linux
319 lfsmake2 vim
320 lfsmake2 grub
321}
322
323buildipfire() {
324 LOGFILE="$BASEDIR/log/_build.ipfire.log"
325 export LOGFILE
326 ipfiremake configroot
327 ipfiremake backup
328 ipfiremake dhcp
329 ipfiremake dhcpcd
330 ipfiremake libusb
331 ipfiremake libpcap
332 ipfiremake ppp
333 ipfiremake rp-pppoe
334 ipfiremake unzip
335 ipfiremake linux SMP=1
336 ipfiremake linux-fusion SMP=1
337 ipfiremake ipp2p SMP=1
338 ipfiremake zaptel SMP=1
339 ipfiremake r8169 SMP=1
340 ipfiremake r8168 SMP=1
341 ipfiremake atl1 SMP=1
342 ipfiremake kqemu SMP=1
343 ipfiremake v4l-dvb SMP=1
344 ipfiremake sane KMOD=1 SMP=1
345 ipfiremake linux
346 ipfiremake linux-fusion
347 ipfiremake ipp2p
348 ipfiremake zaptel
349 ipfiremake r8169
350 ipfiremake r8168
351 ipfiremake atl1
352 ipfiremake kqemu
353 ipfiremake v4l-dvb
354 ipfiremake sane KMOD=1
355 ipfiremake pkg-config
356 ipfiremake linux-atm
357 ipfiremake cpio
358 ipfiremake klibc
359 ipfiremake mkinitcpio
360 ipfiremake udev KLIBC=1
361 ipfiremake expat
362 ipfiremake gdbm
363 ipfiremake gmp
364 ipfiremake pam
365 ipfiremake openssl
366 ipfiremake curl
367 ipfiremake python
368 ipfiremake libnet
369 ipfiremake libidn
370 ipfiremake libjpeg
371 ipfiremake libpng
372 ipfiremake libtiff
373 ipfiremake libart
374 ipfiremake freetype
375 ipfiremake gd
376 ipfiremake popt
377 ipfiremake pcre
378 ipfiremake slang
379 ipfiremake newt
380 ipfiremake libcap
381 ipfiremake pciutils
382 ipfiremake usbutils
383 ipfiremake libxml2
384 ipfiremake libxslt
385 ipfiremake BerkeleyDB
386 ipfiremake mysql
387 ipfiremake cyrus-sasl
388 ipfiremake openldap
389 ipfiremake apache2
390 ipfiremake php
391 ipfiremake apache2 PASS=C
392 ipfiremake arping
393 ipfiremake beep
394 ipfiremake bind
395 ipfiremake cdrtools
396 ipfiremake dnsmasq
397 ipfiremake dosfstools
398 ipfiremake squashfstools
399 ipfiremake reiserfsprogs
400 ipfiremake xfsprogs
401 ipfiremake sysfsutils
402 ipfiremake fuse
403 ipfiremake ntfs-3g
404 ipfiremake ethtool
405 ipfiremake ez-ipupdate
406 ipfiremake fcron
407 ipfiremake perl-GD
408 ipfiremake GD-Graph
409 ipfiremake GD-TextUtil
410 ipfiremake gnupg
411 ipfiremake hdparm
412 ipfiremake sdparm
413 ipfiremake mtools
414 ipfiremake initscripts
415 ipfiremake whatmask
416 ipfiremake iptables
417 ipfiremake libupnp
418 ipfiremake ipp2p IPT=1
419 ipfiremake linux-igd
420 ipfiremake ipaddr
421 ipfiremake iptstate
422 ipfiremake iputils
423 ipfiremake l7-protocols
424 ipfiremake mISDN
425 ipfiremake capi4k-utils
426 ipfiremake hwdata
427 ipfiremake kudzu
428 ipfiremake logrotate
429 ipfiremake logwatch
430 ipfiremake misc-progs
431 ipfiremake nano
432 ipfiremake nasm
433 ipfiremake URI
434 ipfiremake HTML-Tagset
435 ipfiremake HTML-Parser
436 ipfiremake Compress-Zlib
437 ipfiremake Digest
438 ipfiremake Digest-SHA1
439 ipfiremake Digest-HMAC
440 ipfiremake libwww-perl
441 ipfiremake Net-DNS
442 ipfiremake Net-IPv4Addr
443 ipfiremake Net_SSLeay
444 ipfiremake IO-Stringy
445 ipfiremake Unix-Syslog
446 ipfiremake Mail-Tools
447 ipfiremake MIME-Tools
448 ipfiremake Net-Server
449 ipfiremake Convert-TNEF
450 ipfiremake Convert-UUlib
451 ipfiremake Archive-Tar
452 ipfiremake Archive-Zip
453 ipfiremake Text-Tabs+Wrap
454 ipfiremake Locale-Country
455 ipfiremake XML-Parser
456 ipfiremake glib
457 ipfiremake GeoIP
458 ipfiremake fwhits
459 ipfiremake noip_updater
460 ipfiremake ntp
461 ipfiremake openssh
462 ipfiremake openswan
463 ipfiremake rrdtool
464 ipfiremake setserial
465 ipfiremake setup
466 ipfiremake snort
467 ipfiremake oinkmaster
468 ipfiremake squid
469 ipfiremake squid-graph
470 ipfiremake squidguard
471 ipfiremake calamaris
472 ipfiremake tcpdump
473 ipfiremake traceroute
474 ipfiremake vlan
475 ipfiremake wireless
476 ipfiremake libsafe
477 ipfiremake pakfire
478 ipfiremake java
479 ipfiremake spandsp
480 ipfiremake lzo
481 ipfiremake openvpn
482 ipfiremake pammysql
483 ipfiremake cups
484 ipfiremake ghostscript
485 ipfiremake foomatic
486 ipfiremake hplip
487 ipfiremake samba
488 ipfiremake sudo
489 ipfiremake mc
490 ipfiremake wget
491 ipfiremake bridge-utils
492 ipfiremake screen
493 ipfiremake hddtemp
494 ipfiremake smartmontools
495 ipfiremake htop
496 ipfiremake postfix
497 ipfiremake fetchmail
498 ipfiremake cyrus-imapd
499 ipfiremake openmailadmin
500 ipfiremake clamav
501 ipfiremake spamassassin
502 ipfiremake amavisd
503 ipfiremake alsa
504 ipfiremake mpg123
505 ipfiremake mpfire
506 ipfiremake guardian
507 ipfiremake libid3tag
508 ipfiremake libmad
509 ipfiremake libogg
510 ipfiremake libvorbis
511 ipfiremake libdvbpsi
512 ipfiremake lame
513 ipfiremake sox
514 ipfiremake libshout
515 ipfiremake icecast
516 ipfiremake icegenerator
517 ipfiremake mpd
518 ipfiremake mpc
519 ipfiremake xvid
520 ipfiremake libmpeg2
521 ipfiremake cmake
522 ipfiremake libpri
523 ipfiremake asterisk
524 ipfiremake gnump3d
525 ipfiremake libsigc++
526 ipfiremake applejuice
527 ipfiremake ocaml
528 ipfiremake mldonkey
529 ipfiremake libtorrent
530 ipfiremake rtorrent
531 ipfiremake ipfireseeder
532 ipfiremake rsync
533 ipfiremake tcpwrapper
534 ipfiremake portmap
535 ipfiremake nfs
536 ipfiremake nmap
537 ipfiremake ncftp
538 ipfiremake etherwake
539 ipfiremake bwm-ng
540 ipfiremake tripwire
541 ipfiremake sysstat
542 ipfiremake vsftpd
543 ipfiremake which
544 ipfiremake lsof
545 ipfiremake centerim
546 ipfiremake br2684ctl
547 ipfiremake pcmciautils
548 ipfiremake lm_sensors
549 ipfiremake collectd
550 ipfiremake lcd4linux
551 ipfiremake neon
552 ipfiremake subversion
553 ipfiremake tcptrack
554 ipfiremake teamspeak
555 ipfiremake elinks
556 ipfiremake igmpproxy
557 ipfiremake fbset
558 ipfiremake sdl
559 ipfiremake qemu
560 ipfiremake sane
561 ipfiremake netpbm
562 ipfiremake phpSANE
563 ipfiremake tunctl
564 ipfiremake nagios
565 ipfiremake ebtables
566 ipfiremake arptables
567 ipfiremake fontconfig
568 ipfiremake freefont
569 ipfiremake directfb
570 ipfiremake dfb++
571 ipfiremake ffmpeg
572 ipfiremake videolan
573 ipfiremake vdr
574 ipfiremake w_scan
575 ipfiremake git
576 ipfiremake squidclamav
577 ipfiremake bc
578 ipfiremake esniper
579 ipfiremake vnstat
580 ipfiremake vnstati
581}
582
583buildinstaller() {
584 # Run installer scripts one by one
585 LOGFILE="$BASEDIR/log/_build.installer.log"
586 export LOGFILE
587 ipfiremake syslinux
588 ipfiremake as86
589 ipfiremake mbr
590 ipfiremake memtest
591 installmake linux-libc-header
592 installmake binutils
593 ipfiremake uClibc PASS=1
594 ipfiremake gcc INST=1
595 installmake uClibc PASS=2
596 installmake gcc INST=2
597 installmake uClibc PASS=3
598 installmake busybox
599 installmake udev
600 installmake slang
601 installmake newt
602 installmake gettext
603 installmake kbd
604 installmake popt
605 installmake sysvinit
606 installmake misc-progs
607 installmake libaal
608 installmake reiser4progs
609 installmake reiserfsprogs
610 installmake sysfsutils
611 installmake util-linux
612 installmake pciutils
613 installmake zlib
614 installmake mtd
615 installmake wget
616 installmake hwdata
617 installmake kudzu
618 installmake pcmciautils
619 installmake installer
620 installmake initrd
621}
622
623buildpackages() {
624 LOGFILE="$BASEDIR/log/_build.packages.log"
625 export LOGFILE
626 echo "... see detailed log in _build.*.log files" >> $LOGFILE
627
628 installmake strip
629
630 # Generating list of packages used
631 echo -n "Generating packages list from logs" | tee -a $LOGFILE
632 rm -f $BASEDIR/doc/packages-list
633 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
634 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
635 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
636 fi
637 done
638 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
639 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
640 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
641 rm -f $BASEDIR/doc/packages-list
642 # packages-list.txt is ready to be displayed for wiki page
643 beautify message DONE
644
645 # Create images for install
646 ipfiremake cdrom ED=full
647
648 # Check if there is a loop device for building in virtual environments
649 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
650 ipfiremake usb-stick
651 fi
652
653 # Create updater package
654 ipfiremake updater
655 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
656
657 ipfirepackages
658
659 # Cleanup
660 stdumount
661 rm -rf $BASEDIR/build/tmp/*
662
663 # Generating total list of files
664 echo -n "Generating files list from logs" | tee -a $LOGFILE
665 rm -f $BASEDIR/log/FILES
666 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
667 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
668 echo "##" >>$BASEDIR/log/FILES
669 echo "## `basename $i`" >>$BASEDIR/log/FILES
670 echo "##" >>$BASEDIR/log/FILES
671 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
672 fi
673 done
674 beautify message DONE
675
676 cd $PWD
677}
678
679ipfirepackages() {
680 #ipfiremake core-updates
681 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
682 if [ -e $BASEDIR/lfs/$i ]; then
683 ipfiredist $i
684 else
685 echo -n $i
686 beautify message SKIP
687 fi
688 done
689 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
690 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
691 rm -rf $BASEDIR/build/install/packages/*
692}
693
694# See what we're supposed to do
695case "$1" in
696build)
697 clear
698 BUILDMACHINE=`uname -m`
699 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
700 #only restore on a clean disk
701 if [ ! -f log/cleanup-toolchain-2-tools ]; then
702 if [ ! -n "$PACKAGE" ]; then
703 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
704 prepareenv
705 buildtoolchain
706 else
707 PACKAGENAME=${PACKAGE%.tar.gz}
708 beautify build_stage "Packaged toolchain compilation"
709 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
710 tar zxf $PACKAGE
711 prepareenv
712 else
713 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
714 fi
715 fi
716 else
717 echo -n "Using installed toolchain" | tee -a $LOGFILE
718 beautify message SKIP
719 prepareenv
720 fi
721
722 beautify build_start
723 beautify build_stage "Building LFS"
724 buildbase
725
726 beautify build_stage "Building IPFire"
727 buildipfire
728
729 beautify build_stage "Building installer"
730 buildinstaller
731
732 beautify build_stage "Building packages"
733 buildpackages
734 beautify build_end
735 ;;
736shell)
737 # enter a shell inside LFS chroot
738 # may be used to changed kernel settings
739 prepareenv
740 entershell
741 ;;
742clean)
743 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
744 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
745 $LOSETUP -d $i 2>/dev/null
746 done
747 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
748 umount $i
749 done
750 stdumount
751 for i in `seq 0 7`; do
752 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
753 umount /dev/loop${i} 2>/dev/null;
754 losetup -d /dev/loop${i} 2>/dev/null;
755 fi;
756 done
757 rm -rf $BASEDIR/build
758 rm -rf $BASEDIR/cdrom
759 rm -rf $BASEDIR/packages
760 rm -rf $BASEDIR/log
761 if [ -h /tools ]; then
762 rm -f /tools
763 fi
764 beautify message DONE
765 ;;
766downloadsrc)
767 if [ ! -d $BASEDIR/cache ]; then
768 mkdir $BASEDIR/cache
769 fi
770 mkdir -p $BASEDIR/log
771 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
772 FINISHED=0
773 cd $BASEDIR/lfs
774 for c in `seq $MAX_RETRIES`; do
775 if (( FINISHED==1 )); then
776 break
777 fi
778 FINISHED=1
779 cd $BASEDIR/lfs
780 for i in *; do
781 if [ -f "$i" -a "$i" != "Config" ]; then
782 echo -ne "Loading $i"
783 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
784 if [ $? -ne 0 ]; then
785 beautify message FAIL
786 FINISHED=0
787 else
788 if [ $c -eq 1 ]; then
789 beautify message DONE
790 fi
791 fi
792 fi
793 done
794 done
795 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
796 ERROR=0
797 for i in *; do
798 if [ -f "$i" -a "$i" != "Config" ]; then
799 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
800 if [ $? -ne 0 ]; then
801 echo -ne "MD5 difference in lfs/$i"
802 beautify message FAIL
803 ERROR=1
804 fi
805 fi
806 done
807 if [ $ERROR -eq 0 ]; then
808 echo -ne "${BOLD}all files md5sum match${NORMAL}"
809 beautify message DONE
810 else
811 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
812 beautify message FAIL
813 fi
814 cd - >/dev/null 2>&1
815 ;;
816toolchain)
817 clear
818 prepareenv
819 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
820 buildtoolchain
821 BUILDMACHINE=`uname -m`
822 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
823 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
824 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
825 build/{bin,etc,usr/bin,usr/local} \
826 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
827 log >> $LOGFILE
828 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
829 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
830 stdumount
831 ;;
832gettoolchain)
833 BUILDMACHINE=`uname -m`
834 # arbitrary name to be updated in case of new toolchain package upload
835 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
836 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
837 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
838 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
839 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
840 cd $BASEDIR/cache/toolchains
841 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
842 if [ $? -ne 0 ]; then
843 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
844 else
845 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
846 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
847 else
848 exiterror "$PACKAGE.md5 did not match, check downloaded package"
849 fi
850 fi
851 else
852 echo "Toolchain is already downloaded. Exiting..."
853 fi
854 ;;
855othersrc)
856 prepareenv
857 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
858 chroot $LFS /tools/bin/env -i HOME=/root \
859 TERM=$TERM PS1='\u:\w\$ ' \
860 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
861 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
862 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
863 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
864 if [ $? -eq "0" ]; then
865 beautify message DONE
866 else
867 beautify message FAIL
868 fi
869 stdumount
870 ;;
871git)
872 case "$2" in
873 update|up)
874 git pull
875 ;;
876 commit|ci)
877 shift 2
878 git commit $*
879
880 [ "$?" -eq "0" ] || exiterror "git commit $* failed."
881
882 echo -e "${BOLD}Do you want to push, too? [y/N]${NORMAL}"
883 read
884 [ -z $REPLY ] && exit 0
885 for i in y Y j J; do
886 if [ "$i" == "$REPLY" ]; then
887 $0 git push
888 exit $?
889 fi
890 done
891 exiterror "\"$REPLY\" is not a valid answer."
892 ;;
893 dist)
894 git archive HEAD | gzip -9 > ${SNAME}-${VERSION}.tar.gz
895 ;;
896 diff|di)
897 echo -ne "Make a local diff to last revision"
898 git diff HEAD > ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff
899 evaluate 1
900 echo "Diff was successfully saved to ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff"
901 git diff --stat
902 ;;
903 push)
904 [ -z $GIT_USER ] && exiterror "You have to setup GIT_USER first."
905 GIT_URL="ssh://${GIT_USER}@git.ipfire.org/pub/git/ipfire-2.x"
906
907 git push ${GIT_URL} ${GIT_BRANCH}
908 ;;
909 esac
910 ;;
911uploadsrc)
912 PWD=`pwd`
913 cd $BASEDIR/cache/
914 echo -e "Uploading cache to ftp server:"
915 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
916 for i in *; do
917 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
918 grep -q $(basename $i) /tmp/ftplist
919 if [ "$?" -ne "0" ]; then
920 echo -ne "$(basename $i)"
921 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
922 if [ "$?" -ne "0" ]; then
923 beautify message FAIL
924 fi
925 fi
926 done
927 rm -f /tmp/ftplist
928 cd $PWD
929 exit 0
930 ;;
931upload)
932 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
933 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
934 if [ -z $FTP_ISO_PORT ]; then
935 FTP_ISO_PORT=21
936 fi
937 cat <<EOF > .ftp-commands
938mkdir -p $FTP_ISO_PATH$SVN_REVISION
939mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
940quit
941EOF
942 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
943 rm -f .ftp-commands
944
945 case "$2" in
946 iso)
947 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
948
949 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
950 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
951 if [ -e "$i" ]; then
952 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
953 if [ "$?" -eq "0" ]; then
954 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
955 else
956 echo "There was an error while uploading the file $i to the ftp server."
957 exit 1
958 fi
959 fi
960 done
961 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
962 if [ "$3" = "--with-sources-cd" ]; then
963 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
964 fi
965 ;;
966 paks)
967 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
968 if [ "$?" -eq "0" ]; then
969 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
970 else
971 echo -e "There was an error while uploading the packages to the ftp server."
972 exit 1
973 fi
974 ;;
975 esac
976 ;;
977batch)
978 if [ "$2" = "--background" ]; then
979 batch_script
980 exit $?
981 fi
982 if [ `screen -ls | grep -q ipfire` ]; then
983 echo "Build is already running, sorry!"
984 exit 1
985 else
986 if [ "$2" = "--rebuild" ]; then
987 export IPFIRE_REBUILD=1
988 echo "REBUILD!"
989 else
990 export IPFIRE_REBUILD=0
991 fi
992 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
993 screen -dmS ipfire $0 batch --background
994 evaluate 1
995 exit 0
996 fi
997 ;;
998watch)
999 watch_screen
1000 ;;
1001pxe)
1002 case "$2" in
1003 start)
1004 start_tftpd
1005 ;;
1006 stop)
1007 stop_tftpd
1008 ;;
1009 reload|restart)
1010 reload_tftpd
1011 ;;
1012 esac
1013 exit 0
1014 ;;
1015lang)
1016 update_langs
1017 ;;
1018"")
1019 clear
1020 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "LOG: Tail" "Help"
1021 do
1022 case $name in
1023 "IPFIRE: Downloadsrc")
1024 $0 downloadsrc
1025 ;;
1026 "IPFIRE: Build (silent)")
1027 $0 build-silent
1028 ;;
1029 "IPFIRE: Watch Build")
1030 $0 watch
1031 ;;
1032 "IPFIRE: Batch")
1033 $0 batch
1034 ;;
1035 "IPFIRE: Clean")
1036 $0 clean
1037 ;;
1038 "Help")
1039 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1040 cat doc/make.sh-usage
1041 ;;
1042 "LOG: Tail")
1043 tail -f log/_*
1044 ;;
1045 "Exit")
1046 break
1047 ;;
1048 esac
1049 done
1050 ;;
1051config)
1052 make_config
1053 ;;
1054*)
1055 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1056 cat doc/make.sh-usage
1057 ;;
1058esac